
package etunicorn.generated;

import etunicorn.generated.model.UpdateEvenementByIdRequest;
import etunicorn.generated.model.UpdateEvenementRequest;
import etunicorn.generated.model.UpdateParticipeRequest;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


/**
 * No description
 * (Generated with springmvc-raml-parser v.0.8.9)
 * 
 */
@RestController
@RequestMapping("/v1/evenement")
public interface EvenementController {


    /**
     * Obtenir la liste de tout les evenements. Nécessite EVNMT_ADMIN ou EVNMT_ACHETER ou EVNMT_REMBOURSER
     * 
     */
    @RequestMapping(value = "", method = RequestMethod.GET)
    public ResponseEntity<?> getEvenement();

    /**
     * Permet de creer un nouvel evenement. Nécessite EVNMT_ADMIN
     * 
     */
    @RequestMapping(value = "", method = RequestMethod.POST)
    public ResponseEntity<?> updateEvenement(
        @javax.validation.Valid
        @org.springframework.web.bind.annotation.RequestBody
        UpdateEvenementRequest updateEvenementRequest);

    /**
     * Permet de modifier un évènement existant. Nécessite EVNMT_ADMIN
     * 
     */
    @RequestMapping(value = "/{evenementId}", method = RequestMethod.PUT)
    public ResponseEntity<?> updateEvenementById(
        @PathVariable
        Long evenementId,
        @javax.validation.Valid
        @org.springframework.web.bind.annotation.RequestBody
        UpdateEvenementByIdRequest updateEvenementByIdRequest);

    /**
     * Obtenir l'evenement {evenementId}. Nécessite EVNMT_ADMIN ou EVNMT_ACHETER ou EVNMT_REMBOURSER
     * 
     */
    @RequestMapping(value = "/{evenementId}", method = RequestMethod.GET)
    public ResponseEntity<?> getEvenementById(
        @PathVariable
        Long evenementId);

    /**
     * Permet de supprimer l'evenement {evenementId}. Nécessite EVNMT_ADMIN
     * 
     */
    @RequestMapping(value = "/{evenementId}", method = RequestMethod.DELETE)
    public ResponseEntity<?> deleteEvenementById(
        @PathVariable
        Long evenementId);

    /**
     * Permet de notifier que quelqu'un a participer à l'evenement (id de la personne a envoyer)
     * 
     */
    @RequestMapping(value = "/{evenementId}/participe", method = RequestMethod.POST)
    public ResponseEntity<?> updateParticipe(
        @PathVariable
        Long evenementId,
        @javax.validation.Valid
        @org.springframework.web.bind.annotation.RequestBody
        UpdateParticipeRequest updateParticipeRequest);

}
