
package etunicorn.generated;

import etunicorn.generated.model.UpdateRoleByIdRequest;
import etunicorn.generated.model.UpdateRoleRequest;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


/**
 * No description
 * (Generated with springmvc-raml-parser v.0.8.9)
 * 
 */
@RestController
@RequestMapping("/v1/role")
public interface RoleController {


    /**
     * Liste les rôles. Nécessite ROLE_ADMIN
     * 
     */
    @RequestMapping(value = "", method = RequestMethod.GET)
    public ResponseEntity<?> getRole();

    /**
     * Ajoute un nouveau rôle. Nécessite ROLE_ADMIN
     * 
     */
    @RequestMapping(value = "", method = RequestMethod.POST)
    public ResponseEntity<?> updateRole(
        @javax.validation.Valid
        @org.springframework.web.bind.annotation.RequestBody
        UpdateRoleRequest updateRoleRequest);

    /**
     * Supprime un rôle. Nécessite ROLE_ADMIN
     * 
     */
    @RequestMapping(value = "/{nomRole}", method = RequestMethod.DELETE)
    public ResponseEntity<?> deleteRoleById(
        @PathVariable
        String nomRole);

    /**
     * Ajoute une permission à un rôle. Nécessite ROLE_ADMIN
     * 
     */
    @RequestMapping(value = "/{nomRole}", method = RequestMethod.POST)
    public ResponseEntity<?> updateRoleById(
        @PathVariable
        String nomRole,
        @javax.validation.Valid
        @org.springframework.web.bind.annotation.RequestBody
        UpdateRoleByIdRequest updateRoleByIdRequest);

    /**
     * Enlève la permission du rôle. Nécessite ROLE_ADMIN
     * 
     */
    @RequestMapping(value = "/{nomRole}/{nomPermission}", method = RequestMethod.DELETE)
    public ResponseEntity<?> deleteRoleByNomPermission(
        @PathVariable
        String nomPermission,
        @PathVariable
        String nomRole);

    /**
     * Liste les permissions. Nécessite ROLE_ADMIN
     * 
     */
    @RequestMapping(value = "/permission", method = RequestMethod.GET)
    public ResponseEntity<?> getPermission();

}
